import urllib, urllib2, re, xbmcplugin, xbmcgui, xbmc, sys, os, time, pprint, shutil

# plugin constants
__plugin__ = "Grooveshark"
__author__ = "Stephen Denham"
__url__ = ""
__svn_url__ = ""
__version__ = "0.0.1"
__svn_revision__ = ""
__XBMC_Revision__ = ""

MODE_SEARCH_SONGS = 1
MODE_SEARCH_ALBUMS = 2
MODE_SEARCH_ARTISTS = 3
MODE_POPULAR = 4
MODE_FAVORITES = 5
MODE_PLAYLISTS = 6
MODE_ALBUM = 7
MODE_ARTIST = 8
MODE_PLAYLIST = 9
MODE_SONG = 10
MODE_FAVORITE = 11
MODE_UNFAVORITE = 12
MODE_SIMILAR_SONG = 13
MODE_SIMILAR_ARTIST = 14
MODE_FROWN = 15

songsearchlimit = 0
albumsearchlimit = 0
artistsearchlimit = 0

lastID = 0

baseDir = os.getcwd()
resDir = xbmc.translatePath(os.path.join(baseDir, 'resources'))
libDir = xbmc.translatePath(os.path.join(resDir,  'lib'))
imgDir = xbmc.translatePath(os.path.join(resDir,  'img'))
thumbDir = os.path.join('special://masterprofile/plugin_data/music', os.path.join(os.path.basename(os.getcwd()), 'thumb'))

sys.path.append (libDir)
from GrooveAPI import *
groovesharkApi = GrooveAPI()

class _Info:
    def __init__( self, *args, **kwargs ):
        self.__dict__.update( kwargs )
        
class GrovesharkPlayer(xbmc.Player):
    # Player Class: calls function when song changes or playback ends
    def __init__(self, *args, **kwargs):
        xbmc.Player.__init__(self)
        self.function = kwargs[ "function" ]

    def onPlayBackStopped(self):
        print "onPlayBackStopped"
        xbmc.sleep(300)
        if (not xbmc.Player().isPlayingAudio()):
            self.function(0)
    
    def onPlayBackEnded(self):
        print "onPlayBackEnded"
        xbmc.sleep(300)
        if (not xbmc.Player().isPlayingAudio()):
            self.function(1)

    def onPlayBackStarted(self):
        print "onPlayBackStarted"
        self.function(2)

class Groveshark:

    albumImg = xbmc.translatePath(os.path.join(imgDir,  'album.png'))
    artistImg = xbmc.translatePath(os.path.join(imgDir,  'artist.png'))
    favoritesImg = xbmc.translatePath(os.path.join(imgDir,  'favorites.png'))
    playlistImg = xbmc.translatePath(os.path.join(imgDir,  'playlist.png'))
    popularImg = xbmc.translatePath(os.path.join(imgDir,  'popular.png'))
    songImg = xbmc.translatePath(os.path.join(imgDir,  'song.png'))
    defImg = xbmc.translatePath(os.path.join(imgDir,  'default.tbn'))
    fanImg = xbmc.translatePath(os.path.join(baseDir, 'fanart.jpg'))

    songsearchlimit = xbmcplugin.getSetting('songsearchlimit')
    albumsearchlimit = xbmcplugin.getSetting('albumsearchlimit')
    artistsearchlimit = xbmcplugin.getSetting('artistsearchlimit')


    def __init__( self ):
        self._handle = int(sys.argv[1])

    def categories(self):
        
        userid = self._get_login()
        
        # Setup
        groovesharkApi.setRemoveDuplicates(True)
        xbmcplugin.setPluginFanart(int(sys.argv[1]), self.fanImg)
        if os.path.isdir(thumbDir) == False:
            os.makedirs(thumbDir)
        
        self._add_dir('Search songs', '', MODE_SEARCH_SONGS, self.songImg, 0)
        self._add_dir('Search albums', '', MODE_SEARCH_ALBUMS, self.albumImg, 0)
        self._add_dir('Search artists', '', MODE_SEARCH_ARTISTS, self.artistImg, 0)
        self._add_dir('Popular', '', MODE_POPULAR, self.popularImg, 0)
        if (userid != 0):
            self._add_dir('Favorites', '', MODE_FAVORITES, self.favoritesImg, 0)
            self._add_dir('Playlists', '', MODE_PLAYLISTS, self.playlistImg, 0)
            
    def searchSongs(self):
        query = self._get_keyboard(default="", heading="Search songs")
        if (query): 
            songs = groovesharkApi.searchSongs(query, limit = xbmcplugin.getSetting('songsearchlimit'))
            if (len(songs) > 0):
                self._add_songs_directory(songs)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'No matching songs.')
                self.categories()
    
    def searchAlbums(self):
        query = self._get_keyboard(default="", heading="Search albums")
        if (query): 
            albums = groovesharkApi.searchAlbums(query, limit = xbmcplugin.getSetting('albumsearchlimit'))
            if (len(albums) > 0):
                self._add_albums_directory(albums)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'No matching albums.')
                self.categories()
    
    def searchArtists(self):
        query = self._get_keyboard(default="", heading="Search artists")
        if (query): 
            artists = groovesharkApi.searchArtists(query, limit = xbmcplugin.getSetting('artistsearchlimit'))
            if (len(artists) > 0):
                self._add_artists_directory(artists)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'No matching artists.')
                self.categories()
                    
    def favorites(self):
        userid = self._get_login()
        if (userid != 0):
            favorites = groovesharkApi.userGetFavoriteSongs(userid)
            if (len(favorites) > 0):
                self._add_songs_directory(favorites)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'You have no favorites.')
                self.categories()
    
    def popular(self):
        popular = groovesharkApi.popularGetSongs(limit = xbmcplugin.getSetting('songsearchlimit'))
        if (len(popular) > 0):
            self._add_songs_directory(popular)
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'No popular songs.')
            self.categories()
                 
    def playlists(self):
        userid = self._get_login()
        if (userid != 0):
            playlists = groovesharkApi.userGetPlaylists()
            if (len(playlists) > 0):
                self._add_playlists_directory(playlists)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'You have no playlists.')
                self.categories()
                
    def favorite(self, songid):
        userid = self._get_login()
        if (userid != 0):
            xbmc.log("Favorite playSong: " + str(songid))
            groovesharkApi.favoriteSong(songID = songid)
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'You must be logged in', 'to add favorites.')
    
    def unfavorite(self, songid):
        userid = self._get_login()
        if (userid != 0):
            xbmc.log("Unfavorite playSong: " + str(songid))
            groovesharkApi.unfavoriteSong(songID = songid)
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'You must be logged in', 'to remove favorites.')

    def frown(self, songid):
        userid = self._get_login()
        if (userid != 0):
            xbmc.log("Frown playSong: " + str(songid))
            if groovesharkApi.radioFrown(songId = songid) != True:
                xbmc.log("Unable to frown song " + str(songid))
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'You must be logged in', 'to frown a song.')

    def similarSong(self, songid):
        userid = self._get_login()
        if (userid != 0):
            xbmc.log("Frown playSong: " + str(songid))
            if groovesharkApi.radioSong(songId = songid) and groovesharkApi.radioStartSongs() == True:
                self.playNext()
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'Cannot start radio')
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'You must be logged in', 'to update radio song.')

    def similarArtist(self, artistId):
        userid = self._get_login()
        if (userid != 0):
            xbmc.log("Add radio artist of playSong: " + str(artistId))
            if groovesharkApi.radioArtist(artistId = artistId) and groovesharkApi.radioStartArtists() == True:
                self.playNext()
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'Cannot start radio')
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'You must be logged in', 'to update radio artists.')
    
    def album(self,albumid):
        album = groovesharkApi.albumGetSongs(albumId = albumid, limit = xbmcplugin.getSetting('songsearchlimit'))
        self._add_songs_directory(album)
    
    def artist(self, artistid):
        albums = groovesharkApi.artistGetAlbums(artistId = artistid, limit = xbmcplugin.getSetting('albumsearchlimit'))
        self._add_albums_directory(albums)
    
    def playlist(self, playlistid):
        userid = self._get_login()
        if (userid != 0):
            songs = groovesharkApi.playlistGetSongs(playlistId = playlistid, limit = xbmcplugin.getSetting('songsearchlimit'))
            self._add_songs_directory(songs)
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'You must be logged in', 'to get playlists.')
            
    def playSong(self, item):
        url = item.getProperty('url')
        xbmc.log("Playing: " + url)
        xbmc.Player( xbmc.PLAYER_CORE_MPLAYER ).play(url, item)
    
    def playNext(self):
        item = self._get_song_item(groovesharkApi.radioNextSong()[0])
        url = item.getProperty('url')
        self.player = GrovesharkPlayer(xbmc.PLAYER_CORE_PAPLAYER, function=self.onPlayBackChanged)
        self.player.play(url, item)

    def songItem(self, id, name, album, artist, duration, thumb, image):
        url = groovesharkApi.getStreamURL(id)
        songImg = self._get_icon(image, str(id) + "-image")
        print songImg
        if songImg == "":
            songImg = image
        songThm = self._get_icon(thumb, str(id) + "-thumb")
        if songThm == "":
            songThm = thumb
        item = xbmcgui.ListItem(label = artist + " - " + album + " - " + name, path=url, thumbnailImage=songThm, iconImage=songImg)
        item.setInfo( type="Music", infoLabels={ "title": name, "duration": duration, "album": album, "artist": artist} )
        item.setProperty('url', url)
        item.setProperty('thumb', songThm)
        item.setProperty('image', songImg)
        item.setProperty('mimetype', 'audio/mpeg')
        return item
        
    def _get_keyboard(self, default="", heading="", hidden=False):
            kb = xbmc.Keyboard(default, heading, hidden)
            kb.doModal()
            if (kb.isConfirmed()):
                return unicode(kb.getText(), "utf-8")
            return ''
    
    def _get_login(self):
        username = xbmcplugin.getSetting('username')
        password = xbmcplugin.getSetting('password')
        if (username == "" or password == ""):
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'Unable to login.', 'Check username and password in settings.')
            return 0
        else:
            if groovesharkApi.loggedInStatus() == 1:
                groovesharkApi.logout()
            userid = groovesharkApi.loginExt(username, password)
            if (userid != 0):
                xbmc.log("Logged in")
                return userid
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'Unable to login.', 'Check username and password in settings.')
                return 0
    
    def _get_song_item(self, song):
        name = song[0]
        id = song[1]
        duration = song[2]
        album = song[3]
        artist = song[6]
        thumb = song[8]
        image = song[9]
        return self.songItem(id, name, album, artist, duration, thumb, image)            
        
    # File download            
    def _get_icon(self, url, id):
        # Get the channel icon
        localThumb = os.path.join(xbmc.translatePath(os.path.join(thumbDir, str(id)))) + '.tbn'
        try:
            if os.path.isfile(localThumb) == False:
                loc = urllib.URLopener()
                loc.retrieve(url, localThumb)
        except:
            xbmc.log('URL download failed of ' + url + ' to ' + localThumb)
            try:
                shutil.copyfile(self.defImg, localThumb)
            except: pass
            return ""

        return os.path.join(os.path.join(thumbDir, str(id))) + '.tbn'
        
    def _add_songs_directory(self, songs):
        n = len(songs)
        xbmc.log("Found " + str(n) + " songs...")
        i = 0
        while i < n:
            song = songs[i]
            item = self._get_song_item(song)
            songurl = item.getProperty('url')
            songthumb = item.getProperty('thumb')
            songimage = item.getProperty('image')
            songname = song[0]
            songid = song[1]
            songduration = song[2]
            songalbum = song[3]
            songartist = song[6]
            songartistid = song[7]
            u=sys.argv[0]+"?url="+urllib.quote_plus(songurl) \
            +"&mode="+str(MODE_SONG)+"&name="+urllib.quote_plus(songname)+"&id=" \
            +str(songid) \
            +"&album="+urllib.quote_plus(songalbum) \
            +"&artist="+urllib.quote_plus(songartist) \
            +"&duration="+str(songduration) \
            +"&thumb="+urllib.quote_plus(songthumb) \
            +"&image="+urllib.quote_plus(songimage)
            fav=sys.argv[0]+"?url="+urllib.quote_plus(songurl)+"&mode="+str(MODE_FAVORITE)+"&name="+urllib.quote_plus(songname)+"&id="+str(songid)
            unfav=sys.argv[0]+"?url="+urllib.quote_plus(songurl)+"&mode="+str(MODE_UNFAVORITE)+"&name="+urllib.quote_plus(songname)+"&id="+str(songid)
            similarArtist=sys.argv[0]+"?mode="+str(MODE_SIMILAR_ARTIST)+"&id="+str(songartistid)
            similarSong=sys.argv[0]+"?mode="+str(MODE_SIMILAR_SONG)+"&id="+str(songid)
            #frown=sys.argv[0]+"?mode="+str(MODE_FROWN)+"&id="+str(songid)
            menuItems = []
            menuItems.append(("Grooveshark Favorite", "XBMC.RunPlugin("+fav+")"))
            menuItems.append(("Not Grooveshark Favorite", "XBMC.RunPlugin("+unfav+")"))
            menuItems.append(("Listen to similar artist", "XBMC.RunPlugin("+similarArtist+")"))
            menuItems.append(("Listen to similar song", "XBMC.RunPlugin("+similarSong+")"))
            # menuItems.append(("No thanks!", "XBMC.RunPlugin("+frown+")"))
            item.addContextMenuItems(menuItems, replaceItems=False)
            xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=item,isFolder=False)
            i = i + 1
        xbmcplugin.setContent(self._handle, 'songs')
            
    def _add_albums_directory(self, albums):
        xbmc.log("Found " + str(len(albums)) + " albums...")
        i = 0
        while i < len(albums):
            album = albums[i]
            albumArtistName = album[0]
            albumName = album[2]
            albumID = album[3]
            albumImage = album[4]
            self._add_dir(albumName + " - " + albumArtistName, '', MODE_ALBUM, albumImage, albumID)
            i = i + 1
        xbmcplugin.setContent(self._handle, 'albums')
        xbmcplugin.addSortMethod(self._handle, xbmcplugin.SORT_METHOD_ALBUM_IGNORE_THE)
            
    def _add_artists_directory(self, artists):
        xbmc.log("Found " + str(len(artists)) + " artists...")
        i = 0
        while i < len(artists):
            artist = artists[i]
            artistName = artist[0]
            artistID = artist[1]
            self._add_dir(artistName, '', MODE_ARTIST, self.artistImg, artistID)
            i = i + 1
        xbmcplugin.setContent(self._handle, 'artists')
        xbmcplugin.addSortMethod(self._handle, xbmcplugin.SORT_METHOD_ARTIST_IGNORE_THE)
            
    def _add_playlists_directory(self, playlists):
        xbmc.log("Found " + str(len(playlists)) + " playlists...")
        i = 0
        while i < len(playlists):
            playlist = playlists[i]
            playlistName = playlist[0]
            playlistID = playlist[1]
            self._add_dir(playlistName, '', MODE_PLAYLIST, self.playlistImg, playlistID)
            i = i + 1  
        xbmcplugin.setContent(self._handle, 'files')
        xbmcplugin.addSortMethod(self._handle, xbmcplugin.SORT_METHOD_PLAYLIST_ORDER)
      
    def _add_dir(self, name, url, mode, iconimage, id):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&id="+str(id)
        dir=xbmcgui.ListItem(name, iconImage=iconimage, thumbnailImage=iconimage)
        dir.setInfo( type="Music", infoLabels={ "title": name } )
        # Codes from http://xbmc-scripting.googlecode.com/svn/trunk/Script%20Templates/common/gui/codes.py
        menuItems = []
        menuItems.append(("Select", "XBMC.executebuiltin(Action(7))"))
        dir.addContextMenuItems(menuItems, replaceItems=True)
        return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=dir,isFolder=True)

    def onPlayBackChanged(self, change):
        print "onPlayBackChanged " + str(change)
        if change == 0:
            groovesharkApi.radioEnabled = False
            self.musicplaylist.clear()
        if change == 1 and groovesharkApi.radioTurnedOn() == True:
            print "playnext"
            self.player.playNext()
        if change == 1 and groovesharkApi.radioTurnedOn() == False:
            print "clear playlist"
            self.musicplaylist.clear()

   
def get_params():
    param=[]
    paramstring=sys.argv[2]
    if len(paramstring)>=2:
        params=sys.argv[2]
        cleanedparams=params.replace('?','')
        if (params[len(params)-1]=='/'):
            params=params[0:len(params)-2]
        pairsofparams=cleanedparams.split('&')
        param={}
        for i in range(len(pairsofparams)):
            splitparams={}
            splitparams=pairsofparams[i].split('=')
            if (len(splitparams))==2:
                param[splitparams[0]]=splitparams[1]
    print param              
    return param
        
grooveshark = Groveshark();
    
params=get_params()
url=None
name=None
mode=None
id=None

try: url=urllib.unquote_plus(params["url"]) 
except: pass
try: name=urllib.unquote_plus(params["name"])
except: pass
try: mode=int(params["mode"])
except: pass
try: id=int(params["id"])
except: pass

if (id > 0):
    lastID = id

if mode==None:
    grooveshark.categories()
       
elif mode==MODE_SEARCH_SONGS:
    grooveshark.searchSongs()
    
elif mode==MODE_SEARCH_ALBUMS:
    grooveshark.searchAlbums()

elif mode==MODE_SEARCH_ARTISTS:
    grooveshark.searchArtists()

elif mode==MODE_POPULAR:
    grooveshark.popular()

elif mode==MODE_PLAYLISTS:
    grooveshark.playlists()

elif mode==MODE_FAVORITES:
    grooveshark.favorites()

elif mode==MODE_SONG:
    try: name=urllib.unquote_plus(params["name"])
    except: pass
    try: album=urllib.unquote_plus(params["album"])
    except: pass
    try: artist=urllib.unquote_plus(params["artist"])
    except: pass
    try: duration=int(params["duration"])
    except: pass
    try: thumb=urllib.unquote_plus(params["thumb"])
    except: pass
    try: image=urllib.unquote_plus(params["image"])
    except: pass
    song = grooveshark.songItem(id, name, album, artist, duration, thumb, image)
    grooveshark.playSong(song)

elif mode==MODE_ARTIST:
    grooveshark.artist(lastID)
    
elif mode==MODE_ALBUM:
    grooveshark.album(lastID)
    
elif mode==MODE_PLAYLIST:
    grooveshark.playlist(lastID)
    
elif mode==MODE_FAVORITE:
    grooveshark.favorite(lastID)

elif mode==MODE_UNFAVORITE:
    grooveshark.unfavorite(lastID)

elif mode==MODE_SIMILAR_ARTIST:
    grooveshark.similarArtist(lastID)

elif mode==MODE_SIMILAR_SONG:
    grooveshark.similarSong(lastID)

elif mode==MODE_FROWN:
    grooveshark.frown(lastID)
    
if (mode < MODE_SONG):    
    xbmcplugin.endOfDirectory(int(sys.argv[1]))
